/***********************************************************
 * tiutiu License ver.1.0.   see http://tiutiu.net/license/
 * Copyright(c) 2009, tiutiu.net all rights reserved.
 * 1. ۏ؂ƍ҂͐ӔC𕉂ȂƂ̏B
 * 2. hɂ͌̒쌠Ƌɖ{CZX̎gp/B
 * 3. 1,2ɔȂp𖳏ŋB
//*********************************************************/

#include <windows.h>
#include "mybitmap.h"

void mygeterrormsg(char *);
int mylittleendianbytetoint(BYTE *buff, int len);

mybitmap::mybitmap(const char *filename) {
  HANDLE hfile;
  BOOL   b;
  int    start_bitmap_data;
  int    filesize;
  BYTE   buff[54];
  DWORD  readcount;
  int    bitmap_data_length;

  width  = -1; /* [px] */
  height = -1; /* [px] */
  strcpy(errmsg, "no error");

  hfile = CreateFile(filename,
					 GENERIC_READ,    /* ANZX[h */
					 FILE_SHARE_READ, /* L[h     */
					 NULL,
					 OPEN_EXISTING,   /*        */
					 FILE_ATTRIBUTE_NORMAL, /* t@C */
					 NULL);
  if(hfile==INVALID_HANDLE_VALUE){
	return;
  }			 

  /* t@CoCg̓ǂݍ */
  b = subfile(hfile, 0, 54, buff);
  if(!b) {
	// strcpy(errmsg, "read header failed.");
	CloseHandle( hfile );
	return;
  }

  /* t@CŜ̃TCY */
  filesize = mylittleendianbytetoint(buff+2, 4);

  /* rbg}bvf[^̊Jnʒu */
  start_bitmap_data = mylittleendianbytetoint(buff+10, 4);

  /* C[W̉ */
  width = mylittleendianbytetoint(buff+18, 4);

  /* C[W̍ */
  height = mylittleendianbytetoint(buff+22, 4);

  /* rbg}bvf[^̈̊m */
  line_per_length    = width*3+((width*3)%4);
  bitmap_data_length = line_per_length * height;
  bitmap_data = (BYTE *)malloc(sizeof(BYTE)*bitmap_data_length);
  if(!bitmap_data) {
	width  = -1;
	height = -1;
	CloseHandle( hfile );
	return;
  }

  /* rbg}bv̈̎擾 */
  subfile(hfile, start_bitmap_data, bitmap_data_length, bitmap_data);

  CloseHandle( hfile );

} /* bitmap::bitmap */


mybitmap::~mybitmap(void) {
  free(bitmap_data);

} /* ~bitmap */


BOOL mybitmap::subfile(HANDLE hfile,
					   int start_pos,
					   int read_len,
					   BYTE *buff) {
  BOOL  b;
  DWORD dwb;
  DWORD readcount;

  dwb = SetFilePointer(hfile, (LONG)start_pos, NULL, FILE_BEGIN);
  if(dwb==INVALID_SET_FILE_POINTER) {
	mygeterrormsg( errmsg );
	return FALSE;
  }
  /* buff֓ǂݍ */
  b = ReadFile(hfile,       /* ǂݍރt@Cւ̃nh */
			   buff,        /* ǂݍ񂾃f[^̕ۑꏊ   */
			   read_len,    /* ǂݍރoCg             */
			   &readcount,  /* ǂݍ񂾃oCg           */
			   NULL);       /* OVERLAPPED\̂ւ̃|C^(??) */
  if(!b) {
	mygeterrormsg( errmsg );
	return FALSE;
  }
  return TRUE;
} /* mybitmap::subfile */


void mygeterrormsg(char *s) {

  /* G[nhOn */
  DWORD dwError;
  LPVOID lpMsgBuf;
  /* TCHAR szBuf[80]; */
  dwError = GetLastError();
  FormatMessage(
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM,
				NULL,
				dwError,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				(LPTSTR) &lpMsgBuf,
				0, NULL );
  wsprintf(s,
		   "failed with error %d: %s", 
		   dwError, lpMsgBuf); 
  LocalFree(lpMsgBuf);
} /* mygeterrormsg */


int mylittleendianbytetoint(BYTE *buff, int len) {
  int i;
  int n = 0;
  for(i=len-1;i>=0;i--) {
	n = n<<8;
	n += (int)buff[i];
  }
  return n;
} /* mylittleendialbytetoint */

/* end */
